import os
import sys

g_pp = None
def program_path() -> str:
    global g_pp

    if g_pp == None:
        g_pp = os.path.abspath(os.path.split(sys.argv[0])[0])
    
    return g_pp

def project_name() -> str:
    return os.path.split(program_path())[1]

def exists(vault: str, path: str) -> bool:
    fp = os.path.join(program_path(), vault, path)
    return os.path.exists(fp)

def fd_open(vault: str, path: str) -> object:
    fp = os.path.join(program_path(), vault, path)
    return open(fp, 'r')

def fd_write(vault: str, path: str) -> object:
    fp = os.path.join(program_path(), vault, path)
    os.makedirs(os.path.join(program_path(), vault), exist_ok=True)
    return open(fp, 'w')

